//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                             BBandsSeries_Cls.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CMoving_Average                                   | 
//+X----------------------------------------------------------------X+ 
#include <MASeries_Cls.mqh> 
//+X----------------------------------------------------------------X+
//   CMovSeriesTools                                   | 
//+X----------------------------------------------------------------X+ 
#include <MovSeriesTools_Cls.mqh>
//+X----------------------------------------------------------------X+
//   StdDevSeries_Cls.mqh                              | 
//+X----------------------------------------------------------------X+ 
#include <StdDevSeries_Cls.mqh>
//+X================================================================X+
//|                                |
//+X================================================================X+
class CBBands
 {
public:
  double BBandsSeries(uint begin, //     
                       uint prev_calculated, //       
                       uint rates_total, //       
                       int Length, //  
                       double deviation, // 
                       ENUM_MA_METHOD MA_Method, //  
                       double series,  //   ,      bar
                       uint bar,  //  
                       bool set, //   
                       double& DnMovSeries, //        
                       double& MovSeries,  //        
                       double& UpMovSeries  //        
                       ); 
                       
  double BBandsSeries_(uint begin, //     
                        uint prev_calculated, //       
                        uint rates_total, //       
                        int MALength, //   
                        ENUM_MA_METHOD MA_Method, //  
                        int BBLength, //    
                        double deviation, // 
                        double series,  //   ,      bar
                        uint bar,  //  
                        bool set, //   
                        double& DnMovSeries, //        
                        double& MovSeries,  //        
                        double& UpMovSeries  //        
                        ); 
  protected:
    //----    Moving_Average  CStdDeviation
    CStdDeviation     STD;
    CMoving_Average   MA;
 };
//+X================================================================X+
//|                                       |
//+X================================================================X+    
double CBBands::BBandsSeries
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int Length, //  
  double deviation, // 
  ENUM_MA_METHOD MA_Method, // 
  double series,  //   ,      bar
  uint bar,  //  
  bool set, //   
  double& DnMovSeries, //        
  double& MovSeries, //       
  double& UpMovSeries //       
 )
// BBandsMASeries(begin, prev_calculated, rates_total, period, deviation,
          // MA_Method, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----+   
  MovSeries = MA.MASeries(begin, prev_calculated, rates_total, Length, MA_Method, series, bar, set);
  
  //----+   
  double StdDev = STD.StdDevSeries(begin, prev_calculated, rates_total, Length, deviation, series, MovSeries, bar, set);
  DnMovSeries = MovSeries - StdDev;
  UpMovSeries = MovSeries + StdDev;
//----+
  return(StdDev); 
 }
//+X================================================================X+
//|                                       |
//+X================================================================X+    
double CBBands::BBandsSeries_
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int MALength, //   
  ENUM_MA_METHOD MA_Method, // 
  int BBLength, //    
  double deviation, // 
  double series,  //   ,      bar
  uint bar,  //  
  bool set, //   
  double& DnMovSeries, //        
  double& MovSeries, //       
  double& UpMovSeries //       
 )
// BBandsMASeries_(begin, prev_calculated, rates_total, MALength, MA_Method,
      // deviation, BBLength, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----+   
  MovSeries = MA.MASeries(begin, prev_calculated, rates_total, MALength, MA_Method, series, bar, set);
  
  //----+   
  double StdDev = STD.StdDevSeries(begin+MALength+1, prev_calculated, rates_total, BBLength, deviation, series, MovSeries, bar, set);
  DnMovSeries = MovSeries - StdDev;
  UpMovSeries = MovSeries + StdDev;
//----+
  return(StdDev); 
 }
//+X----------------------+ <<< The End >>> +-----------------------X+