//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                                 T3Series_Cls.mqh |
//|                                T3 code: Copyright  1998, Tilson |
//|                MQL5 T3Series: Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//   CMovSeriesTools                                   | 
//+X----------------------------------------------------------------X+ 
#include <MovSeriesTools_Cls.mqh>
//+X================================================================X+
//|                |
//+X================================================================X+
class CT3 : public CMovSeriesTools
 {
public:
  double   T3Series(uint begin, //     
                     uint prev_calculated, //       
                     uint rates_total, //       
                     int  Din, //    Length   . 
                                // 0 -   ,     - .
                     double Curvature, //  (        !)
                     double Length, //  
                     double series,  //   ,      bar
                     uint bar,  //  
                     bool set //   .
                     ); 
protected:
  void     T3Init (uint begin,
                    int Din,
                    double Curvature,
                    double Length,
                    double series,
                    uint bar
                    );

  //----+   
  double   m_b2, m_b3;
  //----
  double   m_e1, m_e2, m_e3, m_e4, m_e5, m_e6;
  double   m_E1, m_E2, m_E3, m_E4, m_E5, m_E6;
  double   m_c1, m_c2, m_c3, m_c4, m_w1, m_w2;
 };
//+X================================================================X+
//|  T3                                                    |
//+X================================================================X+
double CT3::T3Series
 (
  uint begin, //     
  uint prev_calculated, //       
  uint rates_total, //       
  int  Din, //    Length   . 
                    // 0 -   ,     - .
  double Curvature, //  (        !)
  double Length, //  
  double series,  //   ,      bar
  uint bar,  //  
  bool set //   .
 )
// T3Series(begin, prev_calculated, rates_total, Din, Curvature, Length, series, bar, set) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+
  //----      
  if (BarCheck1(begin, bar, set)) return(EMPTY_VALUE);
  
  //----+   
  double e0, T3_;
  
  //----+    Length  
  LengthCheck(Length);	 
  
  //----+  
  T3Init(begin, Din, Curvature, Length, series, bar);
   
  e0 = series; 
  //----+ <<<  T3 >>> 
  m_e1 = m_w1 * e0 + m_w2 * m_e1;
  m_e2 = m_w1 * m_e1 + m_w2 * m_e2;
  m_e3 = m_w1 * m_e2 + m_w2 * m_e3;
  m_e4 = m_w1 * m_e3 + m_w2 * m_e4;
  m_e5 = m_w1 * m_e4 + m_w2 * m_e5;
  m_e6 = m_w1 * m_e5 + m_w2 * m_e6;
  //----  
  T3_ = m_c1 * m_e6 + m_c2 * m_e5 + m_c3 * m_e4 + m_c4 * m_e3;
  
  //----+   
  if (BarCheck5(rates_total, bar, set))
   { 
    m_e1 = m_E1; 
    m_e2 = m_E2; 
    m_e3 = m_E3; 
    m_e4 = m_E4; 
    m_e5 = m_E5;
    m_e6 = m_E6;
   }
  
  //----+   
  if (BarCheck4(rates_total, bar, set))
   {

    m_E1 = m_e1; 
    m_E2 = m_e2; 
    m_E3 = m_e3; 
    m_E4 = m_e4; 
    m_E5 = m_e5; 
    m_E6 = m_e6;
   }
 
//----+     T3Series()
  return(T3_);
 }
//+X================================================================X+
//|     T3                 |
//+X================================================================X+    
void CT3::T3Init
 (
  uint begin,
  int Din,
  double Curvature,
  double Length,
  double series,
  uint bar
 )
// T3InitInit(begin, Din, Curvature, Length, series, bar) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 {
//----+  
  //----+ <<<   >>>
  if (bar == begin || Din != 0) 
   {
    double b = Curvature / 100.0;
    m_b2 = b * b;
    m_b3 = m_b2 * b;
    m_c1 = -m_b3;
    m_c2 = (3 * (m_b2 + m_b3));
    m_c3 = -3 * (2 * m_b2 + b + m_b3);
    m_c4 = (1 + 3 * b + m_b3 + 3 * m_b2);
    double n  = 1 + 0.5 * (Length - 1);
    m_w1 = 2 / (n + 1);
    m_w2 = 1 - m_w1;
    
    if (bar == begin)
     {
      m_e1 = series; 
      m_e2 = series; 
      m_e3 = series; 
      m_e4 = series; 
      m_e5 = series;
      m_e6 = series;
     }
   }
//----+
 }
//+X----------------------+ <<< The End >>> +-----------------------X+